# \label{c2_code_concord}
# Code Sample 2.17 and Program 2.7, pages 32 and 34
#
# Example of usage:
# perl Code_Sample_2-17.pl and 30 text.txt

  open(FILE, "$ARGV[2]") or die("$ARGV[2] not found");
  
  $/ = ""; # Paragraph mode for first while loop
  
  $target = "\\b($ARGV[0])\\b";
  $radius = $ARGV[1];
  $width = 2*$radius; # Width of extract

  # First while loop
  while (<FILE>) {
    chomp;
    s/\n/ /g; # Replace newlines by spaces
    s/--/ -- /g; # Add spaces around dashes
    
    # Second while loop
    while ( $_ =~ /$target/gi ) {
      $match = $1;
      $pos = pos($_);
      $start = $pos - $radius - length($match);
      
      if ($start < 0) {
        $extract = substr($_, 0, $width+$start+length($match));
        $extract = (" " x -$start) . $extract;
        $len = length($extract);
      } else {
        $extract = substr($_, $start, $width+length($match));
      }

      # Print the next concordance line
      print "$extract\n";	
    }
  }

  close(FILE);