# \label{c3_carol_counts}
# Program 3.3 and Code Sample 3.26, pages 81-82

  open(TEXT, "A_Christmas_Carol.txt") or die("Text not found");
  open(OUT, ">Word_Counts.csv");

  while (<TEXT>) {   
    chomp; 
    $_ = lc;  # Convert to lowercase
    s/--/ /g; # Replace dash with space
    s/ +/ /g; # Replace multiple spaces to one space
    s/[.,:;?"!()]//g; # Remove punctuation (except ')
    
    @words = split(/ /);
    
    foreach $word (@words) {
      
      if ( /(\w+)'\W/ ) {
        if ( $1 eq 'Christmas' ) {
          $word =~ s/'//g; # Remove single quote
        }
      }
      if ( /\W'(\w+)/ ) {
        if ( ($1 ne 'change') and ($1 ne 'em') and 
             ($1 ne 'prentices') ) {

          $word =~ s/'//g; # Remove single quote
        }
      }

      $dictionary{$word} += 1; # Increment count for $word
    }
  }

  foreach $word (sort byDescendingValues keys %dictionary) {
    print OUT "$word, $dictionary{$word}\n";
  }

  sub byDescendingValues {
    $value = $dictionary{$b} <=> $dictionary{$a};
    if ($value == 0) {
      return $a cmp $b;
    } else { 
      return $value;
    }
  }
# \label{c3_descending}

  close(TEXT);
  close(OUT);