# \label{c3_shared_words}
# Program 3.7, page 95

  open (IN, "PoeMesmerismStories.txt") or die;

  $nstory = -1; # Counter for number of stories
  
  while (<IN>) { # Read the file
    chomp; 
    if ( $_ =~ /<TITLE> *(.*) *<\/TITLE>/ ) {
      $name[++$nstory] = $1; # Save the name of the story
      print "$1 detected.\n";
    } else {
      $_ = lc;    # Convert to lower case
      s/ -- / /g; # Remove double hyphen dashes
      s/ - / /g;  # Remove single hyphen dashes
      s/ +/ /g;   # Replace multiple spaces with one space
      s/[.,:;?"!_()\[\]]//g; # Remove punctuation
      
      @words = split;
      foreach $w (@words) {
        ++$dict[$nstory]{$w}; # Array of hashes for each story
        ++$combined{$w};  # Hash with all words 
      }
    }
  }

  # Compute number of words in common between any two stories
  for $i ( 0 .. $#dict ) {
    for $j (0 .. $#dict) {
      foreach $word (keys %combined) {
        if ( exists($dict[$i]{$word}) and exists($dict[$j]{$word}) ) 
          { ++$count[$i][$j] }
      }
    }
  }

  # Print results
  for $i ( 0 .. $#dict ) {
    print "@{$count[$i]}\n";
  }

  close(IN);