# \label{c4_char_count}
# Program 4.3, page 111


  # USAGE > perl count_characters.pl FileName.txt
  # This program is case insensitive.
  # This program counts all characters, not just letters.

  open (FILE, "$ARGV[0]") or die("$ARGV[0] not found");
  $/ = ""; # Paragraph mode used

  while (<FILE>) {
    chomp;
    s/\n/ /g; # Replace newlines by spaces
    $_ = lc; # Make letters lower case
    @chars = split(//);

    foreach $char (@chars) {
      ++$freq{$char};
    }
  }

  $count = 0; # Stores total number of letters
  foreach $char ( sort byReverseValues keys %freq ) {
    if ('a' le $char and $char le 'z') {
      $count += $freq{$char};
    }
    print "$char: $freq{$char}\n";
  }

  print "\nTotal number of letters: $count\n";

  foreach $letter ( 'a'..'z' ) {
    print "$letter: $freq{$letter}\n";
  }

  sub byReverseValues {
    $value = $freq{$b} <=> $freq{$a};
    if ($value == 0) { return $a cmp $b; 
          } else { return $value; };
  }   

  close(FILE);