# \label{c4_bigram}
# Program 4.4, page 114

  # USAGE > perl count_bigrams.pl FileName.txt
  # This program is case insensitive
  # Non-letters are ignored

  open (FILE, "$ARGV[0]") or die("$ARGV[0] not found");
  $/ = ""; # Paragraph mode used

  $count = 0;  # Tallies number of bigrams
  while (<FILE>) {
    chomp;
    s/[^a-zA-Z]/ /g; # Substitute spaces for non-letters
    s/ +/ /g;        # Substitute one space for many 
    $_ = lc;         # Convert to lower case

    @words = split(/\s/);

    foreach $word (@words) {
      @letters = split(//, $word);
      for ($i = 0; $i < $#letters; ++$i) {
        $bigram = join('', @letters[$i..($i+1)]);
        ++$freq{$bigram};
        ++$count;
      }
    }
  }

  # Print out results
  foreach $bigram ( sort byReverseValues keys %freq ) {
    print "$bigram: $freq{$bigram}\n";
  }

  print "\nTotal number of bigrams: $count";

  sub byReverseValues {
    $value = $freq{$b} <=> $freq{$a};
    if ($value == 0) { return $a cmp $b; 
              } else { return $value; };
  }   

  close(FILE);