# \label{c5_print_pronouns}
# Code Sample 5.1 and Program 5.2, pages 136-7

  open(IN, "Poe_4_Stories.txt") or die;

  while (<IN>) {
    chomp;
    if ( /<TITLE>(.*)<\/TITLE>/ ) {
      $title = $1; print "TITLE = $title\n"; 
    } else {
      if ($title eq '') { print "NULL TITLE\n"; } 
      $_ = lc;   # Change letters to lower case
      s/--/ /g;  # Remove dashes
      s/ - / /g; # Remove dashes
      s/[,.";!()?:_\[\]]//g; # Remove non-apostrophes
      s/\s+/ /g; # Replace multiple spaces with one space
      s/^\s+//g; # Remove spaces at the start of a line
      @words = split(/ /);
      foreach $word (@words) {
        if ($word =~ /^'?(.*?)'?$/) { # Must be non-greedy
          $word = $1; # Remove initial and final apostrophes
          ++$freq{$title}{$word}; 
        }
      }
    }
  }

  @pronouns = qw(he she him her his hers himself herself);

  foreach $title (sort keys %freq) { 
    foreach $word ( @pronouns ) {
      $freq{$title}{$word} += 0;  # In case of empty strings
      print "$title, $word, $freq{$title}{$word}\n";
    }
  }

  close(IN);