# \label{c6_enron_wordcounts}
# Code Sample 6.1, page 167
#
# This requires the file EnronSent00 from
# http://www.cs.cmu.edu/~enron/

  open(FILE, "C:/enronsent00") or die;
  open(OUT, ">counts.csv") or die;

  sub byDescendingValues {
    $value = $freq{$b} <=> $freq{$a};
    if ($value == 0) {
      return $a cmp $b;
    } else { 
      return $value;
    }
  }

  while(<FILE>) { 
    chomp; 
    $_ = lc($_);
    s/--+/ /g;
    s/''//g; 
    s/(\W)'(\w)/$1$2/g; # Remove apostrophes at start of a word 
    s/(\w)'(\W)/$1$2/g; # Remove apostrophes at end of a word 
    s/[.,\/=*:?_)(>\$"\@<!+&~%\#\[\];`|\\}{]//g; 
    @word = split(/\s+/);
    foreach $x (@word) {
      ++$freq{$x};
    }
  }

  foreach $x (sort byDescendingValues keys %freq) {
    print OUT "$x, $freq{$x}\n";
  }

  close(FILE);
  close(OUT);