# \label{c6_concord}
# \label{c6_concord_print}
# Program 6.1 and Code Sample 6.2, pages 172-3

  # EXAMPLE: perl concordance.pl regex radius
  open (FILE, "Call of the Wild.txt") or die("File not found");
  
  $/ = ""; # Paragraph mode for while loop
  $target = "($ARGV[0])"; print "Target=$target\n\n";
  $radius = $ARGV[1];
  $width = 2*$radius; 
  
  $count = 0;
  while (<FILE>) {
    chomp;
    s/\n/ /g; # Replace newlines by spaces
    s/\b--\b/ -- /g; # Add spaces around dashes adjacent to words
    
    while ( $_ =~ /$target/gi ) {
      $match = $1;
      $pos = pos;
      $start = $pos - $radius - length($match);
      
      # Extracts are padded with spaces if needed
      if ($start < 0) {
        $extract = substr($_, 0, $width+$start+length($match));
        $extract = (" " x -$start) . $extract;
      } else {
        $extract = substr($_, $start, $width+length($match));
        $deficit = $width+length($match) - length($extract);
        if ($deficit > 0) {
          $extract .= (" " x $deficit);
        }
      }
      $lines[$count] = $extract;
      ++$count;
    }
  }

  close(FILE);

# Code Sample 6.2

  $line_number = 0;
  
  foreach $x (@lines) {
    ++$line_number;
    printf "%5d", $line_number;
    print " $x\n";
  }
