# \label{c7_poe68_words}
# \label{c7_poe68_meanwordlength}
# Code Samples 7.1 and 7.2, pages 194-5

  open (IN, "Poe5Volumes.txt") or die;

  $nstory = -1;
  while (<IN>) {
    chomp; 
    if ( $_ =~ /<TITLE> *(.*) *<\/TITLE>/ ) {
      $name[++$nstory] = $1;
      print "$1\n";
    } else {
      $_ = lc;      # Convert to lower case
      s/{\*\d+}//g; # Remove footnote symbols
      s/--+/ /g;    # Remove multiple hyphens
      s/(\W)-(\W)/$1$2/g; # Remove single hyphen dashes
      s/^-(\W)/$1/g;      
      s/(\W)-$/$1/g;      
      s/ +/ /g;     # Replace multiple spaces with one space
      s/[.,:;?"!_()*\[\]]//g; # Remove punctuation
      s/(\w)\'(\W)/$1$2/g; # Remove non-internal single quotes
      s/(\W)\'(\w)/$1$2/g;
      s/^\'//g;
      s/\'$//g;

      @words = split;
      foreach $word (@words) {
        ++$dict[$nstory]{$word}; # Word counts for each story
        ++$combined{$word};      # Overall word counts
        ++$len[$nstory][length($word)]; # Word lengths tallied 
      }
    }
  }

  close(IN);

  for ($index=0; $index <= $#len; ++$index) {
    $n = 0;
    $sum = 0;
    $sum2 = 0;
    for ($value=1; $value <=  @{$len[$index]}-1; ++$value) {
      $n += $len[$index][$value];
      $sum += $len[$index][$value]*$value;
      $sum2 += $len[$index][$value]*$value**2;
    }
    $mean = $sum/$n;   # Compute sample mean
    $var = $sum2/($n-1) - $n/($n-1)*$mean**2;  # Variance
    $sd = sqrt($var);  # Compute sample standard deviation
    printf "%s, %5.0f, %.3f, %.3f, %.3f\n", 
           $name[$index], $n, $mean, $var, $sd;
  }
