# \label{c7_poe68_words}
# \label{c7_poe68_termdoc}
# Code Samples 7.1 and 7.3, pages 194 and 197

  open (IN, "Poe5Volumes.txt") or die;

  $nstory = -1;
  while (<IN>) {
    chomp; 
    if ( $_ =~ /<TITLE> *(.*) *<\/TITLE>/ ) {
      $name[++$nstory] = $1;
      print "$1\n";
    } else {
      $_ = lc;      # Convert to lower case
      s/{\*\d+}//g; # Remove footnote symbols
      s/--+/ /g;    # Remove multiple hyphens
      s/(\W)-(\W)/$1$2/g; # Remove single hyphen dashes
      s/^-(\W)/$1/g;      
      s/(\W)-$/$1/g;      
      s/ +/ /g;     # Replace multiple spaces with one space
      s/[.,:;?"!_()*\[\]]//g; # Remove punctuation
      s/(\w)\'(\W)/$1$2/g; # Remove non-internal single quotes
      s/(\W)\'(\w)/$1$2/g;
      s/^\'//g;
      s/\'$//g;

      @words = split;
      foreach $word (@words) {
        ++$dict[$nstory]{$word}; # Word counts for each story
        ++$combined{$word};      # Overall word counts
        ++$len[$nstory][length($word)]; # Word lengths tallied 
      }
    }
  }

  close(IN);

  sub byValues {
    $value = $combined{$b} <=> $combined{$a};
    if ($value == 0) {
      return $b cmp $a;
    } else { 
      return $value;
    }
  }

  open (OUT, ">Poe68top5.csv") or die; # Changed output file name
  @sortedWords = sort byValues keys %combined;
  $" = ',';
  print OUT "@sortedWords[0..4]\n";

  for $i ( 0 .. $#dict ) {
    $count = 0;
    for $word (@sortedWords) {
      if ($count < 4) {
        print OUT $dict[$i]{$word}+0, ",";
        ++$count;
      } else {
        print OUT $dict[$i]{$word}+0, "\n";
        last;
      }
    }
  }

  close(OUT);
