# \label{c7_poe68_words}
# \label{c7_poe68_pronouns}
# Code Samples 7.1 and 7.4, pages 194 and 209

  open (IN, "Poe5Volumes.txt") or die;

  $nstory = -1;
  while (<IN>) {
    chomp; 
    if ( $_ =~ /<TITLE> *(.*) *<\/TITLE>/ ) {
      $name[++$nstory] = $1;
      print "$1\n";
    } else {
      $_ = lc;      # Convert to lower case
      s/{\*\d+}//g; # Remove footnote symbols
      s/--+/ /g;    # Remove multiple hyphens
      s/(\W)-(\W)/$1$2/g; # Remove single hyphen dashes
      s/^-(\W)/$1/g;      
      s/(\W)-$/$1/g;      
      s/ +/ /g;     # Replace multiple spaces with one space
      s/[.,:;?"!_()*\[\]]//g; # Remove punctuation
      s/(\w)\'(\W)/$1$2/g; # Remove non-internal single quotes
      s/(\W)\'(\w)/$1$2/g;
      s/^\'//g;
      s/\'$//g;

      @words = split;
      foreach $word (@words) {
        ++$dict[$nstory]{$word}; # Word counts for each story
        ++$combined{$word};      # Overall word counts
        ++$len[$nstory][length($word)]; # Word lengths tallied 
      }
    }
  }

  close(IN);

  open (OUT, ">Poe68pronouns.csv") or die; # Changed output file name
  @pronouns = (he, she, him, her, his, hers, himself, herself);
  $" = ',';
  print OUT "@pronouns\n";

  for $i ( 0 .. $#dict ) {
    for ($j = 0; $j < $#pronouns; ++$j) {
      print OUT $dict[$i]{$pronouns[$j]}+0, ",";
    }
    print OUT $dict[$i]{$pronouns[-1]}+0, "\n";;
  }

  close(OUT);