# \label{c7_poe68_words}
# \label{c8_poe_storylength}
# Code Samples 7.1 and 8.1, pages 194 and 225

  open (IN, "Poe5Volumes.txt") or die;

  $nstory = -1;
  while (<IN>) {
    chomp; 
    if ( $_ =~ /<TITLE> *(.*) *<\/TITLE>/ ) {
      $name[++$nstory] = $1;
      print "$1\n";
    } else {
      $_ = lc;      # Convert to lower case
      s/{\*\d+}//g; # Remove footnote symbols
      s/--+/ /g;    # Remove multiple hyphens
      s/(\W)-(\W)/$1$2/g; # Remove single hyphen dashes
      s/^-(\W)/$1/g;      
      s/(\W)-$/$1/g;      
      s/ +/ /g;     # Replace multiple spaces with one space
      s/[.,:;?"!_()*\[\]]//g; # Remove punctuation
      s/(\w)\'(\W)/$1$2/g; # Remove non-internal single quotes
      s/(\W)\'(\w)/$1$2/g;
      s/^\'//g;
      s/\'$//g;

      @words = split;
      foreach $word (@words) {
        ++$dict[$nstory]{$word}; # Word counts for each story
        ++$combined{$word};      # Overall word counts
        ++$len[$nstory][length($word)]; # Word lengths tallied 
      }
    }
  }

  close(IN);

# Code Sample 8.1

  open(SIZE, ">size.csv") or die;
  
  for $i ( 0 .. $#dict ) {
    $sum = 0;
    foreach $x ( keys %{$dict[$i]} ) {
      $sum += $dict[$i]{$x};
    }
    print SIZE "$sum\n";
  }
  close(SIZE);
